PROGRAM Melodie_1;

{ c 1993 by Martin Rtz
zur Eingabe von Noten zum Abspeichern auf Diskette
und Abspielen der Melodien }

USES crt, sbc_tp6, dos;
LABEL Start;
CONST MaxAnzNoten=20; MaxTakt=100;              { bis zu 20 Noten im Takt }
      str2 = '.SBN';                            { fr Sound-Blaster-Noten }
TYPE NotenStruktur = RECORD NName, Nwert: byte END;
VAR TaktNr, NotenNr: byte;
    NotenIndex: ARRAY [1..MaxTakt,1..MaxAnzNoten] of NotenStruktur;
    MusFile: File of NotenStruktur;
    VAR str1 : String[8];
    FileName : String[12];
    ein,Verzweiger: char;
{ ----------------------------------------------------------------------- }
PROCEDURE Fehleingabe;
BEGIN
 writeln('Falsche Eingabe');delay(2000);exit
END;
{ ----------------------------------------------------------------------- }
PROCEDURE Handeingabe;
BEGIN
  clrscr;
  writeln('Tne = MIDI-Daten 24 .. 107 - z.B. c1 = 60');
  writeln('1 = Ganze Note, 2 = Halbenote, 4 = Viertelnote, 8 = Achtelnote');
  writeln('3 = punkt. Viertel,            6 = punkt. Achtel');
  window(1,4,80,22);
  repeat
  clrscr;
    write('Zu bearbeitende Taktnummer = ');readln(TaktNr);
    if (TaktNr<1) or (TaktNr>MaxTakt) then
    BEGIN Fehleingabe; exit END;
    BEGIN
    writeln('Variantenabschluss mit 222');
        NotenNr:=0;
        repeat
          NotenNr := succ(notennr);
          write(NotenNr:4,'.   NotenName = ');
          with NotenIndex[TaktNr,NotenNr] do
           BEGIN
              readln(NName);
              if (NName<24) or ((NName>107) and (NName<>222)) then
                BEGIN Fehleingabe;exit END;
              if NotenNr = MaxAnzNoten then NName:=222;
              if NName<>222 then
                BEGIN
                  write(NotenNr:4,'.te Notenwert = ');readln(NWert);
                  if (NWert<1) or (NWert>32) then BEGIN Fehleingabe;exit END;
                END;
            END;       { of with }
        until NotenIndex[TaktNr,NotenNr].NName = 222;
      END;
      write('Eingabe fortsetzen ((j)/n)? ');ein:=readkey;
  until upcase(ein)='N';
  window(1,1,80,25);
END;     { Handeingabe }
{ ------------------------------------------------------------------------ }
                      { Bildschirmausgabe }
PROCEDURE BsAusgabe;

BEGIN
  repeat
  clrscr;
  writeln('Zeige geladene Datei ',FileName);
  write('Welche Taktnummer? = ');readln(TaktNr);
  if (TaktNr<1) or (TaktNr>maxtakt) then BEGIN Fehleingabe;exit END;
    BEGIN
      writeln;
      NotenNr:=0;
      repeat
        NotenNr:=succ(NotenNr);
        with NotenIndex[TaktNr,NotenNr] do
          BEGIN
            write(NName:4);if NName<>222 then writeln(NWert:4);
          END;  { of with }
      until (NotenIndex[TaktNr,NotenNr].NName=222)
        or  (NotenIndex[TaktNr,NotenNr].NName=0);
      writeln('           <ENTER>');readln;
    END;
    writeln;write('BS-Ausgabe fortsetzen ((j)/n)? ');ein:=readkey;
  until upcase(ein)='N';
end;      { Bildschirmausgabe }
{ ----------------------------------------------------------------------- }
                     { Datei retten }
PROCEDURE SaveDisk;
BEGIN
  clrscr;
  writeln('Bitte Dateinamen ohne Ext. eingeben: ');readln(str1);
  writeln('ACHTUNG Evt. vorh. Datei mit gleichem Namen wird berschrieben!');
  writeln('In Ordnung ((j)/n)? ');ein:=readkey;
  writeln;
    if upcase(ein)='N' then exit;
  FileName := str1+str2;
  assign(Musfile,FileName);
  rewrite(Musfile);
  for TaktNr:=1 to MaxTakt do
      BEGIN
        NotenNr:=0;
        repeat
          NotenNr:=succ(NotenNr);
          write(MusFile,NotenIndex[TaktNr,NotenNr]);
        until (NotenIndex[TaktNr,NotenNr].NName=222)
           or (NotenIndex[TaktNr,NotenNr].NName=0);
      END;
  close(MusFile);

END;         { SaveDisk }
{ ----------------------------------------------------------------------- }
                     { Laden von Diskette }
PROCEDURE LoadDisk;
BEGIN
  clrscr;
  writeln('Verzeichnis der Melodie-Dateien kann noch nicht');
  writeln('angezeigt werden.');
  writeln('Bitte vor Programmstart ber *.SBN Dateien informierem.');
  writeln;
  writeln('Bitte Dateinamen der Melodie ohne Ext. eingeben');
  
  readln(str1);
  Filename := str1 + str2;
  assign(MusFile,FileName);                  { Name der Diskettendatei
                                                    wird zugeordnet         }
  reset(MusFile);                                 { Datei wird geffnet     }
  for TaktNr:=1 to MaxTakt do                     { vom 1. bis letzten Takt } 
      BEGIN
        NotenNr:=0;                             { Notennummer auf 0 stellen }
        repeat
          NotenNr:=succ(NotenNr);                     { nchste Notennummer }
          read(MusFile,NotenIndex[TaktNr,NotenNr]);   { lies Notennummer    }
        until (NotenIndex[TaktNr,NotenNr].NName=222)  { bis Kennzahl 222    }
          or  (NotenIndex[TaktNr,NotenNr].NName=0);   { oder 0 erscheint    }
      END;
  close(MusFile);
END;         { LoadDisk }
{ ----------------------------------------------------------------------- }
                          { Melodie spielen }
PROCEDURE MelodieSpiel;
CONST TdFaktor = 400; stacc=100;              { Tempo und Nachklingen }
VAR Ton      : word;
    Tondauer : real;
    Takt, Instrument : byte;
    Instr    : String[2];
    Titel    : String[10];
    Tempo, Fehlerstelle : integer;
BEGIN
sbfd_init;                                     { SB-Karte initialisieren }
  clrscr;
  write('Instrumentennummer (0..15): ');
  readln (Instr);
  Val(Instr, Instrument,Fehlerstelle);
  if Fehlerstelle = 0 then
  BEGIN
  write('Tempo ( 1 - schnell ... 12 - langsam): ');readln(Tempo);
  if (Tempo<1) or (Tempo>12)  then BEGIN Fehleingabe; exit END;
  writeln; 
  Titel := FileName;
  writeln('Spiele ',Titel,' mit Instrument ',Instrument,' in Tempo ',Tempo);
  sbfd_program_change(0,Instrument);            { Instrument einstellen }
  for Takt:=1 to MaxTakt do                     { vom 1. bis letzten Takt }
    BEGIN
      NotenNr:=1;                               { Notennummer auf 1 stzen }
      while (NotenIndex[Takt,NotenNr].NName<>222) and  { wenn gltige     }
            (NotenIndex[Takt,Notennr].NName<>0) do     { Notennummern     }
        BEGIN
          with NotenIndex[Takt,NotenNr] do    { mit Feld der Notennummern }
            BEGIN
              Ton:= NName;                        { zu spielender Ton    }
              TonDauer:=  (TdFaktor div NWert)*Tempo; { Tondauer errechnen }
            END;   { of with }

          sbfd_note_on(0,Ton,120);                { schaltet Ton ein     }
          delay (round(TonDauer));                { hlt Notenwert aus   }
          sbfd_note_off(0,Ton,120);               { schaltet Ton ab      }
          delay (stacc);                          { lt Ton nachklingen }
          NotenNr:=succ(NotenNr)                  { nchste Notennummer  }
        END;
    END;
 sbfd_reset;                                     { SB-Karte zurcksetzen   }
 END;
END;      { von MelodieSpiel }
{ ----------------------------------------------------------------------- }
                         { Hauptprogramm }
BEGIN
  fillchar(notenindex,sizeof(notenindex),0);
 textcolor (14); textbackground (1);
  repeat
  start:clrscr;
  gotoxy(22,2);  write('*****    Noteneingabe    *****');
  gotoxy(22,3);  write('zur Abspeicherung auf Diskette');
  gotoxy(24,6);  write('1 = Handeingabe Notendatei');
  gotoxy(24,8);  write('2 = Bildschirmansicht der Notendatei');
  gotoxy(24,10); write('3 = Notendatei auf Diskette');
  gotoxy(24,12); write('4 = Notendatei laden');
  gotoxy(24,14); write('5 = Melodie spielen');
  gotoxy(24,16); write('6 = E n d e');
  Verzweiger := readkey;
  case Verzweiger of
    '1':  BEGIN Handeingabe; goto start END;
    '2':  BEGIN BsAusgabe; goto start END;
    '3':  BEGIN SaveDisk; goto start END;
    '4':  BEGIN LoadDisk; goto start END;
    '5':  BEGIN MelodieSpiel; goto start END;
  END; { of case }
 until Verzweiger='6';
    clrscr
END.

