PROGRAM WICHTEL;
{ Marsch der Wichtel }

{ Einbindung der SBC-Unit und die weiterhin bentigten Units }
USES sbc_tp6, dos, crt;

CONST
  { Instrumente }
  inst : array[0..9] of array[0..15] of byte =
                ( ( $21,$11,$4c,$00,$f1,$f2,$63,$72,
                    $00,$00,$04,$00,$00,$00,$00,$00 ),

                  ( $a5,$b1,$d2,$80,$81,$f1,$03,$05,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$1c,$05,$51,$52,$03,$13,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $11,$01,$8a,$40,$f1,$f1,$11,$b3,
                    $00,$00,$06,$00,$00,$00,$00,$00 ),

                  ( $21,$11,$11,$00,$a3,$c4,$43,$22,
                    $02,$00,$0d,$00,$00,$00,$00,$00 ),

                  ( $31,$a1,$1c,$80,$41,$92,$0b,$3b,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$c5,$05,$6e,$8b,$17,$0e,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $41,$91,$83,$00,$65,$32,$05,$74,
                    $00,$00,$0a,$00,$00,$00,$00,$00 ),

                  ( $32,$16,$87,$80,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),

                  ( $01,$13,$8d,$00,$51,$52,$53,$7c,
                    $01,$00,$0c,$00,$00,$00,$00,$00 ) );

CONST
     c=48; d=50; e=52; f=53; g=55; a=57; h=59;        { MIDI-Daten }
     c1=60; d1=62; e1=64; f1=65; g1=67; a1=69; h1=71; { fr drei   }
     c2=72; d2=74; e2=76; f2=77; g2=79; a2=81; h2=83; { Oktaven    }
     c3=84;
     P=0;                                             { fr Pausen }
     Grundschlag=6000;
VAR
    Instrument : byte;
    Auswahl:integer;

{ ----------------------------------------------------------- }
PROCEDURE Bildschirm;
BEGIN
 textcolor (14);textbackground (1);clrscr;
            gotoxy(33,2);
            write('mr soft 1993');
            gotoxy(19,4);
            write('Musikprogramme fr die SOUND BLASTER Karte');
            gotoxy(23,7);
            Write('W I C H T E L W E R K  S T A T T ');
            gotoxy(23,8);
            write('*********************************');
            gotoxy(22,9);
            write('aus "Weihnachtsmusik in fnf Stzen"');
            gotoxy(32,11);
            write('von MARTIN RTZ'); 
END;
{ ----------------------------------------------------------- }
PROCEDURE Ton (Hoehe1, Hoehe2, Laenge : integer);

     BEGIN                                 { beide Stimmen pausieren }
        if (Hoehe1=0) and (Hoehe2=0) then      
                delay (round (Grundschlag/Laenge))
     else
        if (Hoehe1)=0 then                 { erste Stimme pausiert }
           BEGIN
              sbfd_note_on(1,hoehe2,$40);
                 delay (round (Grundschlag/Laenge));
              sbfd_note_off(1,hoehe2,$40);
           END
     else                                  { zweite Stimme pausiert }
        if (Hoehe2)=0 then
           BEGIN
              sbfd_note_on(0,Hoehe1,$40);
                 delay (round (Grundschlag/Laenge));
              sbfd_note_off(0,Hoehe1,$40);
           END
     else                                  { keine Pause dabei }
           BEGIN
              sbfd_note_on(0,Hoehe1,$40);
              sbfd_note_on(1,Hoehe2,$40);
                 delay (round (Grundschlag/Laenge));
              sbfd_note_off(0,Hoehe1,$40);
              sbfd_note_off(1,Hoehe2,$40);
          END;
     END;
{ ----------------------------------------------------------- }
PROCEDURE Einleitung;
BEGIN
    Ton(P,c,8);Ton(P,P,8);Ton(P,g,8);Ton(P,P,8);
    Ton(P,e,8);Ton(P,f,8);Ton(P,e,8);;Ton(P,d,8);
    Ton(P,c,8);Ton(P,P,8);Ton(P,g,8);Ton(P,P,8);
    Ton(P,e,8);Ton(P,f,8);Ton(P,e,8);;Ton(P,d,8);
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv1;
BEGIN
    Ton(g1,c1,8);;Ton(g1,c1,8);Ton(a1,f1,8);;Ton(a1,f1,8);
    Ton(g1,e1,8);Ton(c2,e1,8);Ton(h1,d1,8);Ton(g1,d1,8);
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv2;
BEGIN
    Ton(a1,c1,8);;Ton(a1,c1,8);Ton(h1,h,8);;Ton(h1,h,8);
    Ton(c2,a,8);Ton(d2,a,8);Ton(e2,a,8);Ton(e2,c1,8);
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv3;
BEGIN
    Ton(f2,d1,8);;Ton(f2,d1,8);Ton(d2,h,8);;Ton(d2,h,8);
    Ton(e2,c1,8);Ton(f2,c1,8);Ton(g2,e1,8);Ton(g2,e1,8);
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv4;
BEGIN
    Ton(a2,f1,8);;Ton(a2,f1,8);Ton(g2,e1,8);;Ton(e2,e1,8);
    Ton(d2,g1,8);Ton(e2,g,8);Ton(c2,c1,4);
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv5;
BEGIN
    Ton(d2,P,8);;Ton(d2,P,8);Ton(d2,P,8);;Ton(h1,g1,8);
    Ton(e2,c2,8);Ton(e2,c2,8);Ton(e2,a1,8);Ton(c2,a1,8);
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv6;
BEGIN
    Ton(f2,P,8);;Ton(f2,d1,8);Ton(f2,d1,8);;Ton(d2,g1,8);
    Ton(e2,c1,8);Ton(e2,a,8);Ton(d2,h,8);Ton(d2,g,8);
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv7;
BEGIN
    Ton(g1,c1,8);;Ton(g1,c1,8);Ton(a1,f1,8);;Ton(a1,f1,8);
    Ton(g1,e1,8);Ton(c2,e1,8);Ton(h1,d1,8);Ton(f2,d1,8);
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv8;
BEGIN
    Ton(e2,c1,8);;Ton(g2,e1,8);Ton(a2,f1,8);;Ton(a2,d1,8);
    Ton(d2,f,8);Ton(e2,g,8);Ton(c2,c1,8);Ton(P,c,8);
END;
{ ----------------------------------------------------------- }
PROCEDURE Einlage1;
BEGIN
    Ton(c,g,2);Ton(a,f,4);Ton(g,c,4);
END;
{ ----------------------------------------------------------- }
PROCEDURE Einlage2;
BEGIN
    Ton(c,g,8);Ton(a,f,8);Ton(c,g,8);Ton(f,d,8);
END;
{ ----------------------------------------------------------- }
PROCEDURE Schluss;
BEGIN
    Ton(P,c,8);Ton(P,P,8);Ton(P,g,8);Ton(P,P,8);
    Ton(P,e,8);Ton(P,f,8);Ton(P,e,8);;Ton(P,d,8);
    Ton(P,c,8);Ton(P,P,8);Ton(P,g,8);Ton(P,P,8);
    Ton(P,e,8);Ton(P,f,8);Ton(P,e,8);;Ton(P,d,8);
     Ton(e2,c1,8);;Ton(g2,e1,8);Ton(a2,f1,8);;Ton(a2,d1,8);
    Ton(d2,f,4);Ton(e2,g,4);Ton(c2,c1,8);Ton(P,c,8);
END;

{ ----------------------------------------------------------- }
PROCEDURE spiele;

VAR
    i,j : word;
    Instrument1, Instrument2 : byte;
    Anzahl,Tempo,Wert : integer;
                    
BEGIN
      RANDOMIZE;       
          Instrument1 := random(10);
          Instrument2 := Instrument1; 
           gotoxy(28,15);
            write('1. Stimme - Instrument: ',instrument1);
             gotoxy(28,17);
            write('2. Stimme - Instrument: ',instrument2);
             gotoxy(40,24);
             sbfd_program_change(0,instrument1);
             sbfd_program_change(1,instrument2);

        Einleitung;
        Motiv1;Motiv2;Motiv3;Motiv4;       { 1. Teil  }

        Motiv5;Motiv6;Motiv7;Motiv8;       { 2. Teil mit Wiederholung }
        Einlage1;Einlage2;

      repeat                               { zufllige Zusammenstellung     }
            instrument1 := random(10);     { der Motive mit                 }
            instrument2 := random(10);     { unterschiedlichen Instrumenten }

            gotoxy(28,15);
            write('1. Stimme - Instrument: ',instrument1);
             gotoxy(28,17);
            write('2. Stimme - Instrument: ',instrument2);
             sbfd_program_change(0,instrument1);
             sbfd_program_change(1,instrument2);
            Auswahl := random (12)+1;
            gotoxy(28,20);
            write('IMPROVISATION - Motiv: ',Auswahl,' ');
            gotoxy(23,23);
            write ('   Abbrechen mit beliebiger Taste');
            gotoxy(40,24);
            gotoxy(40,24);
            case Auswahl of
                 1 : Motiv1;
                 2 : Motiv2;
                 3 : Motiv3; 
                 4 : Motiv4;
                 5 : Motiv5;
                 6 : Motiv6;
                 7 : Motiv7;
                 8 : Motiv8;
                10 : Einleitung;
                11 : Einlage1;
                12 : Einlage2;
                 END; { of case   }

      until keypressed;
             gotoxy(23,23);
            write ('                                 ');
            gotoxy(40,24);
            gotoxy(28,20);
            write('------- E N D E ---------');
            gotoxy(40,24);
            Schluss

END;

{ ------------------------------------------------------------------------ }
                           { Hauptprogramm }
BEGIN

    if GetEnvSetting = 0 then
  BEGIN

        if boolean( sbc_check_card and $0002 ) then
        BEGIN
          Bildschirm;
            sbfd_init;
            sbfd_instrument(@inst);
             spiele;
             sbfd_reset;
            clrscr;
         END
        else
            writeln('Sound-Blaster-Karte nicht gefunden oder Falsches I/O-Setting.');
    END
    else
        writeln('BLASTER-Environment-Variable nicht gesetzt, unvollstndig oder falsch.');

END.
